@echo off

set key_type=ECDSA

if "${key_type}" == "ECDSA" (
    @rem create private key in pkcs1 format
    @rem   without passphrase
    @rem openssl ecparam -name secp256k1 -genkey -noout -out agent.key
    @rem   with passphrase
    openssl ecparam -genkey -name secp256k1 | openssl ec -aes256 -passout pass:"jobscheduler" -out agent.key

    @rem create certificate
    openssl req -new -x509 -key agent.key -passin pass:"jobscheduler" -out agent.crt -days 1825

    @rem extract public key from private key
    openssl ec -in agent.key -passin pass:"jobscheduler" -pubout > agent.pub
) else (
    @rem create private key in pkcs1 format
    @rem  without passphrase
    @rem  openssl req -x509 -sha256 -newkey rsa:2048 -keyout agent.key -out agent.crt
    @rem  with passphrase
    openssl req -x509 -sha256 -newkey rsa:2048 -passout pass:"jobscheduler" -keyout agent.key -out agent.crt

    @rem extract public key from certificate
    openssl x509 -pubkey -noout -in agent.crt > agent.pub
)

